import { registerExtension } from 'vscode/extensions';

const manifest = {"name":"scala","displayName":"Scala Syntax (official)","description":"Official Scala Syntax","version":"0.5.7","publisher":"scala-lang","license":"SEE LICENSE IN LICENSE.md","engines":{"vscode":"^1.5.0"},"homepage":"https://github.com/scala/vscode-scala-syntax/blob/main/README.md","repository":{"type":"git","url":"https://github.com/scala/vscode-scala-syntax.git"},"icon":"images/smooth-spiral.png","categories":["Programming Languages"],"contributes":{"languages":[{"id":"scala","aliases":["Scala","scala"],"extensions":[".scala",".sbt",".sc"],"configuration":"./language-configuration.json"}],"grammars":[{"language":"scala","scopeName":"source.scala","path":"./syntaxes/Scala.tmLanguage.json"}]},"devDependencies":{"@types/node":"^14.6.4","ajv":"^6.12.4","github-changes":"^2.0.2","npm-run-all":"^4.1.5","rimraf":"^3.0.2","ts-node":"^9.0.0","typescript":"^4.0.2","vsce":"^2.7.0","vscode-tmgrammar-test":"0.0.11"},"scripts":{"clean":"rimraf scala-*.vsix","vscode:prepublish":"test -f ./syntaxes/Scala.tmLanguage.json","vscode:publish":"vsce publish --yarn","build":"npm-run-all build:syntax build:extension","build:syntax":"ts-node src/typescript/GenerateTmLanguageFile.ts > ./syntaxes/Scala.tmLanguage.json","build:extension":"vsce package --yarn","test":"npm-run-all test:*","test:unit":"vscode-tmgrammar-test -s source.scala -g syntaxes/Scala.tmLanguage.json -t 'tests/unit/**/*.test.scala'","test:snap":"vscode-tmgrammar-snap -s source.scala -g syntaxes/Scala.tmLanguage.json -t 'tests/snap/**/*.test.scala'","update:snapshots":"vscode-tmgrammar-snap --updateSnapshot -s source.scala -g syntaxes/Scala.tmLanguage.json -t 'tests/snap/**/*.test.scala'"}};

const { registerFileUrl, whenReady } = registerExtension(manifest);


registerFileUrl('syntaxes/Scala.tmLanguage.json', new URL('../assets/scala-lang.scala-0.5.7.vsix/Scala.tmLanguage.json', import.meta.url).href, 'application/json');

registerFileUrl('language-configuration.json', new URL('../assets/scala-lang.scala-0.5.7.vsix/language-configuration.json', import.meta.url).href, 'application/json');

registerFileUrl('package.json', new URL('../assets/scala-lang.scala-0.5.7.vsix/package.json', import.meta.url).href, 'application/json');

export { whenReady };
